import { Box, Button, Drawer, Typography } from "@mui/material";
import React, { useState } from "react";
import { FilterAlt } from "@mui/icons-material";
import { Stack } from "@mui/system";
function DefaultFilterButton({ onClick }) {
    return (React.createElement(Button, { variant: "outlined", startIcon: React.createElement(FilterAlt, null), onClick: onClick }, "More Filters"));
}
export default function ListingAdvanceFilters({ ToggleFilterButton = DefaultFilterButton, title = "More Filters", children, }) {
    const [isOpen, setIsOpen] = useState(false);
    const onToggle = () => setIsOpen((f) => !f);
    return (React.createElement(React.Fragment, null,
        React.createElement(ToggleFilterButton, { onClick: onToggle }),
        React.createElement(Drawer, { open: isOpen, anchor: "right", keepMounted: true, onClose: onToggle },
            React.createElement(Stack, { sx: { height: "100%", px: 2, minWidth: { xs: "80vw", md: 250 } }, spacing: 2 },
                React.createElement(DrawerHeaderDrawer, { title: title }),
                React.createElement(Stack, { sx: { height: "100%", paddingBottom: 10 }, spacing: 2 }, children),
                React.createElement(DrawerBottom, { onToggle: onToggle })))));
}
// Subcomponents for more filters
function DrawerBottom({ onToggle }) {
    return (React.createElement(Stack, { direction: "row", spacing: 1, sx: ({ palette }) => ({
            backgroundColor: "Background",
            position: "sticky",
            bottom: 0,
            py: 2,
        }) },
        React.createElement(Button, { fullWidth: true, variant: "outlined", onClick: onToggle }, "Close")));
}
function DrawerHeaderDrawer({ title }) {
    return (React.createElement(Box, { sx: ({ palette }) => ({
            borderBottom: 1,
            borderColor: palette.divider,
            backgroundColor: "Background",
            position: "sticky",
            zIndex: 1,
            top: 0,
            py: 1,
        }) },
        React.createElement(Typography, { variant: "h6" }, title)));
}
