/// <reference types="react" />
import { TQueryListFunc } from "../types";
import { GridValidRowModel, DataGridProps, GridColumns } from "@mui/x-data-grid";
export default function Listing<T extends GridValidRowModel>({ defaultLimit, listingKey, queryFunc, onSuccess, columns, ...remaining }: {
    onSuccess?: (data: {
        nextToken: string;
        total: number;
        items: T[];
    }) => void;
    queryFunc: TQueryListFunc<T>;
    columns: GridColumns<T>;
    defaultLimit?: number;
    listingKey: string;
} & Partial<Omit<DataGridProps, "columns">>): JSX.Element;
