var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { MenuItem, TextField } from "@mui/material";
import { useFilterController } from "./ListingFilterCore";
import React from "react";
const NONE = "none";
export default function ListingFilterDropdown(_a) {
    var { options, name } = _a, remaining = __rest(_a, ["options", "name"]);
    const { value, onChange, resetFilter } = useFilterController({
        queryFunc: getDropdownQuery,
        name,
    });
    function getDropdownQuery(v) {
        var _a;
        const selection = options.filter(({ value }) => value === v);
        return (_a = selection[0]) === null || _a === void 0 ? void 0 : _a.query;
    }
    function onDropdownChange(v) {
        if (v === NONE)
            resetFilter();
        else
            onChange(v);
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(TextField, Object.assign({ onChange: (e) => onDropdownChange(e.target.value), variant: "outlined", value: value || NONE, select: true }, remaining),
            React.createElement(MenuItem, { value: NONE }, "None"),
            options.map(({ label, value }) => (React.createElement(MenuItem, { key: value, value: value }, label))))));
}
