import { useFilterController } from "./ListingFilterCore";
import { FormControlLabel, FormControl, FormLabel, FormGroup, Checkbox, } from "@mui/material";
import React, { useCallback, useEffect } from "react";
export default function ListingMultiSelect({ options, name, title, }) {
    const getDropdownQuery = useCallback((v) => {
        return {
            and: options
                .filter(({ value }) => v.includes(value))
                .map(({ query }) => query),
        };
    }, []);
    const { value, onChange, resetFilter } = useFilterController({
        queryFunc: getDropdownQuery,
        name,
    });
    useEffect(() => {
        if ((value === null || value === void 0 ? void 0 : value.length) === 0)
            resetFilter();
    }, [value]);
    const bucketValue = value || [];
    return (React.createElement(FormControl, { sx: { m: 3 }, component: "fieldset", variant: "standard" },
        React.createElement(FormLabel, { component: "legend", sx: { fontSize: "sm" } }, title),
        React.createElement(FormGroup, null, options === null || options === void 0 ? void 0 : options.map(({ label, value: v }) => (React.createElement(FormControlLabel, { key: v, label: label, control: React.createElement(Checkbox, { checked: bucketValue === null || bucketValue === void 0 ? void 0 : bucketValue.includes(v), name: label, onChange: () => {
                    if (bucketValue === null || bucketValue === void 0 ? void 0 : bucketValue.includes(v))
                        onChange(bucketValue === null || bucketValue === void 0 ? void 0 : bucketValue.filter((f) => f !== v));
                    else
                        onChange([...bucketValue, v]);
                } }) }))))));
}
