import { useEffect, useState } from "react";
function useDebounce(value, onDebounce, delay) {
    const [debouncedValue, setDebouncedValue] = useState(value);
    useEffect(() => {
        const timer = setTimeout(() => {
            setDebouncedValue(value);
            onDebounce(value);
        }, delay || 500);
        return () => {
            clearTimeout(timer);
        };
    }, [value, delay, onDebounce]);
    return debouncedValue;
}
export default useDebounce;
