var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useListingFilterProvider } from "../components/ListingFilterCore";
import { useQuery } from "@tanstack/react-query";
import { useState } from "react";
export function useListingCore({ defaultLimit, listingKey, queryFunc, onSuccess, }) {
    const { getCurrentFilterQuery } = useListingFilterProvider();
    const [sortModel, setSortModel] = useState([]);
    const [limit, setLimit] = useState(defaultLimit || 20);
    const [nextToken, setNextToken] = useState();
    const [page, setPage] = useState(0);
    const { data, isLoading } = useQuery({
        queryKey: [listingKey, sortModel, limit, page, getCurrentFilterQuery()],
        onSuccess: (data) => {
            setNextToken(data === null || data === void 0 ? void 0 : data.nextToken);
            if (onSuccess)
                onSuccess(data);
        },
        queryFn: () => __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            let sort;
            if ((sortModel === null || sortModel === void 0 ? void 0 : sortModel.length) > 0)
                sort = { direction: (_a = sortModel[0]) === null || _a === void 0 ? void 0 : _a.sort, field: (_b = sortModel[0]) === null || _b === void 0 ? void 0 : _b.field };
            const filter = getCurrentFilterQuery();
            return yield queryFunc({ nextToken, limit, page, sort, filter });
        }),
    });
    const hello = {
        setSortModel,
        sortModel,
        isLoading,
        setLimit,
        setPage,
        limit,
        page,
        data,
    };
    return hello;
}
